;;;;;;;;; -*- Emacs-Lisp -*- ;;;;;;;;;

;; auto-load
;; browse-url-plus $B$O(B macro $B$J$N$G(B, $B:G8e$N(B t t $B$rK:$l$:$K$D$1$k$3$H(B
;; browse-url-plus-compose-mail $B$*$h$S(B browse-url-plus-wget-url $B$O4X?t$J$N$G(B
;; $B:G8e$O(B t $B$@$1$G$h$$(B
(autoload 'browse-url-plus "browse-url-plus" "A little-extension for browse-url" t t)
(autoload 'browse-url-plus-compose-mail
  "browse-url-plus" "A little-extension for browse-url" t)
(autoload 'browse-url-plus-wget-url
  "browse-url-plus" "A little-extension for browse-url" t)
(autoload 'browse-url-plus-x
  "browse-url-plus" "A little-extension for browse-url" t)
(autoload 'irchat "irchat" "GNUemacs IRC client." t)

;;; ----------------------------------------------------------------
;;; irchat $B0lHL@_Dj(B

;;; $B=q$-49$($,I,MW$JItJ,(B
;; IRC server $B$N;XDj(B
(setq irchat-server "irc.karrn.ad.jp")
(setq irchat-name "hogehoge foo@bar.com")
(setq irchat-nickname "hogehoge")

;; default $B$G;22C$9$k(B channel $B$N(B list
;; ($B$3$3$K=q$$$?(B channel $B$K$O(B irchat $B$N5/F0$HF1;~$K;22C$G$-$^$9(B)
(setq irchat-startup-channel-list '("#$B$A$c$M$k(B1" "#$B$A$c$M$k(B2"))

;; C-($B?t;z(B)$B$N(B key-bind $B$N7hDj(B. $B:G=i$+$i=g$K(B,
;;   C-1, C-2, ..., C-9, C-c C-c 0, C-c C-c 1, ..., C-c C-c 9,
;;   C-c C-d 0, C-c C-d 1, ..., C-c C-d 9
;; $B$H$J$j$^$9(B.
(setq irchat-default-channel-binding
      '("#$B$A$c$M$k(B1" "#$B$A$c$M$k(B2" "#$B$A$c$M$k(B3" nil "#$B$A$c$M$k(B5"))

;;; ----------------------------------------------------------------
;;; $B3F<o$3$^$+$$8D?M@_Dj(B

;; nick $B$*$h$S(B channel $B$NBP>]HO0O(B
;; t  : $B%5!<%P$K@\B3$7$F$$$kA4%f!<%6$N(B nick $B$*$h$S(B $BB8:_$9$kA4(B channel
;; nil: $B<+J,<+?H$,8+$($kHO0O$G$N(B nick $B$*$h$S(B channel
(setq irchat-global-names nil)
;; $B@ZCG$5$l$?$H$-<+F0@\B3$9$k$+$I$&$+(B
(setq irchat-reconnect-automagic t)
;; channel $B$4$H$K(B buffer $B$r:n@.$9$k$+$I$&$+(B
(setq irchat-channel-buffer-mode t)
;; channel $B$4$H$N(B buffer $B$K$D$$$F(B, $B3FH/8@$4$H$K(B channel $BL>$rI=<($9$k$+$I$&$+(B
;; t  : <#$B$A$c$M$k(B:nick> $B$,$,!D(B
;; nil: <nick> $B$,$,!D(B
(setq irchat-display-channel-always t)
;; channel buffer $B$r<+F0E*$K%9%/%m!<%k$5$;$J$$$+$I$&$+(B
;; t: $B$5$;$J$$(B, nil: $B$5$;$k(B
(setq irchat-default-freeze-local nil)
;; \007 $B$N%3!<%I$r<u$1<h$C$?$H$-$K(B beep $B$rLD$i$9$+$I$&$+(B
(setq irchat-beep-on-bells t)
;; quit $B$9$k$H$-$N%a%C%;!<%8(B
(setq irchat-signoff-msg "irchat-pj exiting...")

;;; ----------------------------------------------------------------
;;; irchat-pj $BFH<+$N@_Dj(B

;; SJIS$B$dF|K\8l(BEUC$B%3!<%I$r<u$1<h$C$?$H$-$K(B, minibuffer $B$K$=$N;]I=<($9$k$+$I$&$+(B
(setq irchat-pj-code-verbose t)
;; invite $B$5$l$?$H$-$K(B beep $B$rLD$i$9$+$I$&$+(B
(setq irchat-pj-beep-when-invited t)
;; buffer $B$r$D$/$C$F$$$J$$(B nick $B$N?M$+$i8D?M08$X$N(B private message $B$r(B
;; $B<u$1<h$C$?$H$-$K(B beep $B$rLD$i$9$+$I$&$+(B
(setq irchat-pj-beep-when-private t)
;; private message $B$b$7$/$O(B notice $B7A<0$G(B server $B$+$i$N(B message $B$r(B
;; $B<u$1<h$C$?$H$-(B, $B=q$-49$($r9T$&$+$I$&$+(B
(setq irchat-pj-rewrite-server-notice t)
;; channel buffer $B$N(B mode-line $B$r;XDj(B
(setq irchat-pj-chanbuf-mode-line-format 'irchat-pj-chanbuf-mode-line-format-minor-mode)

;;; ----------------------------------------------------------------
;;; browse-url $B$*$h$S(B browse-url-plus $B$N@_Dj(B

;; mailto: $B7A<0$N(B URL $B$r<u$1<h$C$?$H$-$K8F$V4X?t$N;XDj(B
;; ($B@53N$K$O(B, browse-url-plus-compose-mail $BFbIt$G8F$P$l$k4X?t(B)
(setq browse-url-plus-compose-mail-function 'mew-send)

;; browse-url $BF1Ey$N4X?t$r$R$H$D:n@.(B
(browse-url-plus browse-url-alternative "URL to wget: "
		 browse-url-alternative-browser-function)

;; $B%V%i%&%68F$S=P$74X?t$NDj5A(B
(setq browse-url-browser-function
      '(("^mailto:" . browse-url-plus-compose-mail)
	("."        . browse-url-netscape)))

(setq browse-url-alternative-browser-function
      '(("^mailto:" . browse-url-plus-compose-mail)
	("."        . browse-url-plus-wget-url)))

;; $B%-!<%P%$%s%I(B
(define-key global-map [C-return] 'browse-url)
(define-key global-map [M-return] 'browse-url-alternative)

;;; end
