#! /usr/local/bin/perl
#
#  mint - IRC Bottle-fed System Version 1.0 (alpha)
#
#    copyright 1999,2000 Puttun.R.T(Puttun!puttun@comel.or.jp)
#

$mint_version = "1.00a2";

# import
use Socket;
#use I18N::Japanese "format";	# jperlܸѤʾ
#no  I18N::Japanese;					# Ʊ

# ޥɥץؿ
push @{$process{topic}}, \&topic;
push @{$process{join}}, \&join;
push @{$process{part}}, \&part;
push @{$process{quit}}, \&quit;
push @{$process{kick}}, \&kick;
push @{$process{mode}}, \&mode;
push @{$process{nick}}, \&nick;
push @{$process{invite}}, \&invite;
push @{$process{privmsg}}, \&privmsg;
push @{$process{notice}}, \&notice;
push @{$process{ping}}, \&ping;
push @{$process{pong}}, \&pong;
push @{$process{kill}}, \&kill;
push @{$process{c001}}, \&c001;
#c205
#c311
#c312
#c319
#c314
#c369
#c352
push @{$process{c353}}, \&c353;
push @{$process{c432}}, \&c432;
push @{$process{c433}}, \&c433;
push @{$process{c437}}, \&c437;
push @{$process{c463}}, \&c463;
push @{$process{c464}}, \&c464;
push @{$process{c465}}, \&c465;
push @{$process{c471}}, \&c471;
push @{$process{c472}}, \&c472;
push @{$process{c473}}, \&c473;
push @{$process{c474}}, \&c474;

# add import									# ɥϿ
#use add::inviter;						# InviteJoinƤ
#use add::AutoOper;						# ưۤ
#use add::AutoKick;						# ưå
#use add::dice;
#use add::sw;
#use add::calc;
#use add::greeting;
#use add::omikuji;
#use add::naruter;
#use add::alarmclock;
#use add::timesignal;
#use add::nickget;
use add::henji1;
use add::henji2;

# Ķ
$version	= "mint $mint_version on perl $]";
$ENV{LANG}	=
$ENV{LC_TIME}	=
$ENV{LC_CTYPE}	=
$ENV{LC_ALL}	= "C";
$home		= $ENV{HOME};
$rcfile		= $ENV{LSRC} || "./mint.rc";
$rcfile		= "$home/mint.rc" unless (-f $rcfile);
($uname, $gcos)	= (getpwuid($<))[0, 6];
$gcos =~ s/,.*$//;

# 
$interval	= 10;				# åԤ򤹤(sec)
$server_retry	= 15;		# ³˥ȥ饤ֳ(sec)
$server_check	= 120;	# åֳ(sec)
$mask		= '';					# select֥å󥰥ޥ

# եǽ ǥե
$rc_nick	= $uname;
$rc_name	= $gcos;
$rc_uinfo	= "running on mint botsystem";
$rc_ldir	= "./log%m%d";
$rc_cmax	= 5;

# ե뤫ɤߤ
unless (-r $rcfile) {
    print STDERR "Can not read file. [$rcfile]\n";
    print STDERR "Please read \"README.euc\".\n";
    exit 1;
}
open(RC, "<$rcfile") or die "Can not open file. [$rcfile]\n";
while(<RC>) {
	next if (m/^\#/ || m/^\s*$/);	# ȤȶԤϼΤƤ
	unless (($arg, $var) = m/^([^\s]+)\s+(.+)$/) {
		print STDERR "Warnning: Line $. in $rcfile\n";
		print STDERR "Skip this line.\n";
		next;			# ʸˡߥ
	}
	
	# ѿ
	$rc_nick	= $var if ($arg =~ m/^nick$/i);
	$rc_name	= $var if ($arg =~ m/^name$/i);
	$rc_pass	= $var if ($arg =~ m/^password$/i);
	$rc_uinfo	= $var if ($arg =~ m/^userinfo$/i);
	$rc_chan	= $var if ($arg =~ m/^channel$/i);
	$rc_ldir	= $var if ($arg =~ m/^logdir$/i);
	$rc_cmax	= $var if ($arg =~ m/^cache$/i);
	$debug .= "$var\n" if ($arg =~ m/^debug$/i);
	
	# üѥ᡼ν
	if ($arg =~ m/^server$/i) { # ̾
		push @rc_server, $var;
		push @rc_spass, "";
		push @rc_port, [6667]; # ǥեǤȤ
	}
	if ($arg =~ m/^serverpass$/i) { # Хѥ
		$rc_spass[$#rc_spass] = $var;
	}
	if ($arg =~ m/^port$/i) { # ݡ
		$rc_port[$#rc_port] = [split(/,/, $var)];
	}
	else {			# ɥѤ⤷ʤΤ¸
		$arg =~ tr/A-Z/a-z/;
		$rc_etc{$arg} = $var;
	}
}
close(RC);

# Ϣ
@cache = (0 .. $rc_cmax);
@nl_server = @rc_server;
@nl_spass = @rc_spass;
@nl_port = @rc_port;

die "Please write SERVER in $rcfile.\n" unless ($nl_server[0]);
die "Please write PASSWORD in $rcfile.\n" unless ($rc_pass);

# ͥ
for $chan (split(/,/, $rc_chan)) {
	next unless ($chan);
	if ($chan =~ m/^(.+)\s(.+)$/) {
		($chan, $key) = ($1, $2);
	} else {
		$key = "";
	}
	next unless (&ChanNameCheck($chan));
	$channel{$chan}{key} = $key;
}

# 
exit if (fork);			# ꤢ
close(STDIN);
close(STDOUT);
#close(STDERR);
if (open(TTY, "+/dev/tty")) {
	ioctl(TTY, 0x20007471, 0);
	close(TTY);
}

#$SIG{HUP}  = load;		# Hang-up ɽ
$SIG{INT}  =			# ʥ
$SIG{QUIT} = 
$SIG{XCPU} = 
$SIG{BUS}  =
$SIG{FPE}  =
$SIG{SEGV} =
$SIG{TERM} = signal_trap;
#$SIG{STOP} = save;		# STOPǽ񤭹
#$SIG{CONT} = load;		# CONTɤ߽Ф

&log("*** mint start. ($$)");
#&load;
srand time;
$server_ctime = time - $server_retry - 1;
$server_alive = undef;

# ᥤ롼
for (;;) {
	# ɤߡ񤭡顼Ԥ
	($nfound, $leftt) = select($rm = $mask, undef, undef, $interval);
	$passt = $interval - $leftt; # в
	if ($nfound < 0) {		# ̿Ū顼С
		&log("*** Fatal error in select(2). exit program. ");
		exit 1;
	}
	if ($nfound == 0) {		# timeout
		if ($server_alive) {	# ³桩
			if (time - $server_ttime > $server_check) {	# ̿Ƥʤ
				$server_ttime = time; # Ǹ̿ΤϺ
				&send("PING LS"); # Ԥ󤰤
			}
		} else {		# ³
			if ((time - $server_ctime > $server_retry) || ($nc_server ne $nl_server[0])) {	# ³ȥ饤Ԥ
				$server_ctime = time;
				$nc_server = shift(@nl_server); push @nl_server, $nc_server;
				$nc_spass = shift(@nl_spass); push @nl_spass, $nc_spass;
				$nc_port = shift(@nl_port); push @nl_port, $nc_port;
				&connect_server($nc_server, $nc_spass, $$nc_port[rand(@{$nc_port})]); # ³ȥ饤
			}
		}
	} elsif ($rm eq $mask) {	# ǡ褿
		unless (sysread(SERVER, $tmp, 1024)) { # 1kbytesޤɤ
			&log("*** server is close !! ");
			&close_server;
		} else {		# ɤ᤿
			$server_ttime = time;
			$ReadBuf .= $tmp;	# Хåե˲ä
			while (split(/\r?\n/, $ReadBuf, 2) == 2) {
				$line = &j2e($_[0]); # Хåեɤߤ
				$ReadBuf = $_[1];
				&log(&j2e("DEBUG: R> $line")) if ($debug =~ m/^recv$/mi);
				&server_proc($line);	# Խ򤹤
			}
			$ReadBuf = $_[0];
		}
	}
	&send("") if (@msgbuf);
	
	#&{$addin{interval}}($passt);
}

# Ф˽Τʤ
die "There is eternity, here is it.\n";

# ʲ֥롼 ################################################################

# ³
sub connect_server ($$$) {
	my $host = shift;
	my $pass = shift;
	my $port = shift;
	my $proto = getprotobyname("tcp");
	
	&log("*** Connect try ");
	$port   = getservbyname($port, "tcp") if ($port =~ m/\D/);
	my $lh  = `hostname`;	# ꤢ
	chomp($lh);
	my $me  = sockaddr_in(0, inet_aton($lh));
	my $ent = sockaddr_in($port, inet_aton($host));
	
	socket(SERVER, PF_INET, SOCK_STREAM, $proto) or return 0;
	if ($ENV{'OSTYPE'} !~ m/linux/i) {
		bind(SERVER, $me) or return 0;
	}
	$server_ctime = time;
	unless (connect(SERVER, $ent)) {
		&log("*** Cannot connect to $host($port)");
		return 0;
	}
	&log("*** server $host($port)");
	vec($mask, fileno(SERVER), 1) = 1;
	select(SERVER); $| = 1;
	$server_alive = 1;
	&send("PASS $pass") if ($pass);
	&send("USER $uname * $host :$rc_name");
	$nick = $rc_nick; &send("NICK $nick");
	&log("*** wait respons ... ");
	
	$connect_process = 1;
	return 1;
}

# ͥ̾RFC˽򤷤Ƥ뤫Ĵ٤
sub ChanNameCheck ($) {
	my $euc = shift;
	my $chan = &e2j($chan);	# Network CodeѴ
	
	if ($chan =~ m/[\s\a\0\r\n\,]/) { # Ȥʤʸ
		&log("*** Illigal char in $euc");
		return 0;
	} elsif ($chan =~ m/^[^\#\&]/) { # Ƭʸ
		&log("*** Illigal header in $euc");
		return 0;
	} elsif (length($chan) > 200) { # Ĺ
		&log("*** $euc is so long name");
		return 0;
	} else {
		return 1;
	}
}

# åȤ
sub send {
	return unless ($server_alive); # Ǥ
	
	my $msg = &e2j(join("", @_));
	chomp($msg);
	
	if (length($msg) > 512) {	# դʸĹ
		&log("*** so long line");
		&log("*** $msg ");
		return;
	}
	
	push(@msgbuf, $msg . "\n") if ($msg); # Хåե­
	my $sbuf = "";		# Хåե
	
	while($msg = shift @msgbuf) {
		$t = time;
		unless ($t-$server_pt+10 > 0) { # 饤ȥڥʥƥγǧ
			unshift(@msgbuf, $msg);
			last;
		}
		if (length($sbuf+$msg) > 512) {
			print SERVER $sbuf;
			&log(&j2e("DEBUG: S> $sbuf")) if ($debug =~ m/^send$/mi);
			$sbuf = $msg;
			if ($t+2 > $server_pt) { # 饤ȥڥʥƥλ
				$server_pt = $t+2;
			} else {
				$server_pt += 2;
			}
		} else {
			$sbuf .= $msg;
		}
	}
	
	$t = time;
	unless ($t-$server_pt+10 > 0) {
		unshift(@msgbuf, $sbuf) if ($sbuf);
		&log("DEBUG: wait for flood $#msgbuf line.") if ($debug =~ m/^flood$/mi);
	} else {
		print SERVER $sbuf if ($sbuf);
		&log(&j2e("DEBUG: S>$sbuf")) if ($debug =~ m/^send$/mi);
		if ($t+2 > $server_pt) { # 饤ȥڥʥƥλ
			$server_pt = $t+2;
		} else {
			$server_pt += 2;
		}
	}
	
	return;
}

# Ȥ
sub log($) {
	my $msg = join("", @_);
	my ($sec, $min, $hour, $day, $mon, $year) = localtime(time);
	$mon++;
	
	chomp($msg);
	#&{$addin{log}}($year, $mon+1, $day, $hour, $min, $msg);
	
	$day = "0".$day if ($day < 10);
	$mon = "0".$mon if ($mon < 10);
	$year = "0".$year if ($year < 10);
	
	my $logf = $rc_ldir;
	$logf =~ s/\%Y/$year+1900/ge
	$logf =~ s/\%y/$year/g;
	$logf =~ s/\%m/$mon/g;
	$logf =~ s/\%d/$day/g;
	
	open(LOG, ">>$logf"); $|=1;
	print LOG sprintf("%02d:%02d:%02d %s\n", $hour, $min, $sec, $msg);
	close(LOG);

}

# Ȥ³Ĥ
sub close_server {
	close(SERVER);
	$mask = '';
	$server_alive = 0;
	#&{$addin{down}};
#    &connect_server($rc_server, $rc_port) unless ($server_pong);
}

# Υǡ
sub server_proc($) {
	my ($from, $where, $command, $rest) = (shift =~ m/^(:[^! ]*)?(![^ ]*)? *([^ ]+) :?(.*)$/);
	
	$from  =~ s/^://;
	$where =~ s/^!//;
	$where =~ s/^(~\-\^)//;
	$command =~ tr/A-Z/a-z/;
	$command = "c$command" unless ($command =~ m/\D/);
	
	&log("DEBUG: from[$from] where[$where] cmd[$command] rest[$rest]") if ($debug =~ m/^process$/mi);
	
	if (defined($process{$command}) && ref($process{$command})) {
		for $process_ref (@{$process{$command}}) {
			if (ref($process_ref) && defined(&$process_ref)) {
				&log("DEBUG: processing function [$command]") if ($debug =~ m/^process$/mi);
				&$process_ref($from, $where, $rest);
			} else {
				&log("DEBUG: [$command] is defined, but can't call function.") if ($debug =~ m/^process$/mi);
			}
		}
	} else {
		&log("DEBUG: [$command] is not defined.") if ($debug =~ m/^process$/mi);
	}
}

sub e2j {
	my $euc = shift;
	my $jis = "";
	
	while($euc =~ /([\0-\177]*)([^\0-\177]+)(.*)$/) {
		$jis .= $1;		# US-ASCIIʤΤǤΤޤ
		my $tmp = $2;		# ܸ죲Хʸ
		$tmp &= "\177" x length($tmp);	# MSB
		$jis .= "\033\$B$tmp\033\(B"; # KI, KOǶɲ
		$euc = $3;		# ĤäʬϺĴ٤
	}
	$jis .= $euc;		# ǸޤǻĤäʬUS-ASCIIʤΤǤΤޤɲ
}

sub j2e {
	my $jis = shift;
	my $euc = "";
	
	while ($jis =~ /^([^\033]*)\033..([^\033]*)\033..(.*)$/) {
	$euc .= $1;		# KIUS-ASCIIȻפΤǤΤޤ
	my $tmp = $2;		# KI,KOʤΤܸ죲Хʸ
		$tmp |= "\200" x length($tmp); # MSBΩƤ
		$euc .= $tmp;		# ɲ
		$jis = $3;		# ĤϺĴ٤
	}
	$euc .= $jis;		# ǸޤǻĤäΤUS-ASCIIʤΤǤΤޤɲ
}

# ʥѴؿ
sub signal_trap {
	my $sig = shift;
	
	&log("*** Terminate system ($sig)");
	
	&send("QUIT :$sig");
	#&save;
	exit;
}

sub topic($$$) {
	my ($from, $where, $rest) = @_;
	my ($chan, $topic) = split(/ /, $rest, 2);
	
	$topic =~ s/^://;
	&log("Topic of $chan by $from: $topic");
}

sub join($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($rest =~ m/\007/) {
		my $sm;
		($rest, $sm) = ($rest =~ m/^(.+)\007(.+)$/);
		$channel{$rest}{member}{$from} = $sm;
		&log("+ $from($where) to $rest with mode +$sm");
	} else {
		$channel{$rest}{member}{$from} = "-";
		&log("+ $from($where) to $rest");
	}
}

sub part($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($rest =~ m/\s/) {
		my $pm;
		($rest, $pm) = split(/ /, $rest, 2);
		&log("- $from $rest($pm)");
	} else {
		&log("- $from $rest");
	}
	if ($from eq $nick) {
		delete $channel{$rest};
	} else {
		delete $channel{$rest}{member}{$from};
	}
}

sub quit($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($rest) {
		&log("! $from ($rest)");
	} else {
		&log("! $from");
	}
	for $c (keys %channel) {
		if ($channel{$c}{member}{$from}) {
			delete $channel{$c}{member}{$from};
		}
	}
}

sub kick($$$) {
	my ($from, $where, $rest) = @_;
	my ($chan, $to, $msg) = ($rest =~ m/^([^ ]+) ([^ ]+) :?(.*)$/);
	
	&log("- $to $chan by $from\'s kick($msg)");
	if ($to eq $nick) {
		delete $channel{$chan};
		if ($channel{$chan}{key}) {
			&send(sprintf("JOIN %s %s", $chan, $channel{$chan}{key}));
		} else {
			&send("JOIN $chan");
		}
	} else {
		delete $channel{$chan}{member}{$to};
	}
}

sub mode($$$) {
	my ($from, $where, $rest) = @_;
	my ($chan, $mode) = split(/ /, $rest, 2);
	my (@tmp, $nm, $pr);
	
	&log("Mode by $from: $chan $mode");
#return ($chan, $mode) if ($rc_remode !~ m/^on$/i);
	
	@tmp = ($mode =~ m/\S+/g);
	while(@tmp) {
		for $c (split(//, shift(@tmp))) {
			if ($c eq "+" || $c eq "-") { # +/-Ȥäȿž..ʤ
				$nm = $c;
			} else {
		  	if ($c eq "o") { # ͥ륪ڥ졼
					if ($pr = shift(@tmp)) {
						if ($nm eq "+") {
							$channel{$chan}{member}{$pr} = "o";
						} else {
							$channel{$chan}{member}{$pr} = " ";
						}
					}
				} elsif ($c eq "v") { # ǥ졼ȯ
					if ($pr = shift(@tmp)) {
						if ($nm eq "+") {
							$channel{$chan}{member}{$pr} = "v" if ($channel{$chan}{member}{$pr} eq " ");
						} else {
							$channel{$chan}{member}{$pr} = " " if ($channel{$chan}{member}{$pr} eq "v");
						}
					}
				}
			}
		}
	}
}

sub nick($$$) {
	my ($from, $where, $rest) = @_;
	
	&log("$from -> $rest");
	if ($from eq $nick) {
		$nick = $rest;
		$nick =~ s/^ *//;
		$nick =~ s/ *$//;
	}
	
	for $c (keys %channel) {
		if ($channel{$c}{member}{$from}) {
			$channel{$c}{member}{$rest} = $channel{$c}{member}{$from};
			delete $channel{$c}{member}{$from};
		}
	}
}

sub invite($$$) {
	my ($from, $where, $rest) = @_;
	my ($to, $chan) = split(/ /, $rest, 2);
	
	$chan =~ s/^://;
	&log("Invited by $from: $chan");
}

sub privmsg($$$) {
	my ($from, $where, $rest) = @_;
	my ($to, $tmp) = ($rest =~ m/^([^ ]+) *:(.*)$/);
	my $message = "";
	
	while ($tmp =~ m/^([^\001]*)\001([^\001]*)\001(.*)/) {
		$message = $1;
		$tmp     = $3;
		&ctrl_a_msg($from, $where, $to, $2);
	}
	$message .= $tmp;
	if ($message) {
		if ($to =~ m/^[\#&]/) {
			if ($channel{$to}{member}{$from}) {
				&log("<$to:$from> $message");
			} else {
				&log("($to:$from) $message");
			}
		} else {
			&log("=$from= $message");
		}
	}
}

sub notice($$$) {
	my ($from, $where, $rest) = @_;
	
	&log("Notice from $from: $rest");
}

sub ping($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($nc_server eq $rest) {
		&send("PONG yourself");
		&log("DEBUG: Self Ping") if ($debug =~ m/^ping\-pong$/mi);
	} else {
		&send("PONG $rest");
		&log("DEBUG: Remote Ping from $rest") if ($debug =~ m/^ping\-pong$/mi);
	}
}

sub pong($$$) {
	my ($from, $where, $rest) = @_;
	
	$server_pong = 0 if ($rest =~ m/^\S+ LS-FIRST$/ && $server_pong);
}

sub make_chans_names($$) {
	my $chan = shift;
	my $list = shift;
	
	if ($channel{$chan}) {
		for (split(/ /, $list)) {
			if (m/^\@(.+)/) {
				$_ = $1;
				$channel{$chan}{member}{$_} = "o";
			} elsif (m/^\+(.+)/) {
				$_ = $1;
				$channel{$chan}{member}{$_} = "v";
			} else {
				$channel{$chan}{member}{$_} = "-";
			}
		}
	}
}

sub kill($$$) {
	my ($from, $where, $rest) = @_;
	my ($to, $msg) = ($rest =~ m/^^([^ ]+) *:?(.*)$/);
	
	&log("Killed by $from: $msg");
}

# welcomeå
sub c001($$$) {
	my ($from, $where, $rest) = @_;
	my @nokey  = ();
	my @keys   = ();
	my @usekey = ();
	
	&send("PING LS-FIRST");
	$server_pong  = 1;
	
	for $chan (keys %channel) {
		next unless ($chan);
		if (&ChanNameCheck($chan)) {
			if ($channel{$chan}{key}) {
				push(@usekey, $chan);
				push(@keys, $channel{$chan}{key});
			} else {
				push(@nokey, $chan);
			}
		} else {
			&log("*** BAD channel name($chan). ");
		}
	}
	&send("JOIN " . join(',', @usekey, @nokey) . " " . join(',', @keys));
	
	#³нˤɤ
	@nl_server = @rc_server;
	@nl_spass = @rc_spass;
	@nl_port = @rc_port;
	
	$connect_process = 0;
}

# trace replay
# 桼ȥ졼η
#sub c205($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($hops, $to, $user, $fqdn) = ($rest =~ m/^\S+ User (\d+) :?(.+)\[([^\@]+)\@(.+)\]/);
#}

# whois replay
# Ĵ٤Υ桼
#sub c311($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($to, $user, $fqdn, $toname) = ($rest =~ m/^\S+ (\S+) (\S+) (\S+) \* :?(.*)/);
#}

# Ĵ٤Υ
#sub c312($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($to, $nserver, $com) = ($rest =~ m/^\S+ (\S+) (\S+) :?(.*)/);
#}

# Ĵ٤JOINΥͥ
#sub c319($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($to, $chan_list) = ($rest =~ m/^\S+ (\S+) :?(.*)/);
#}

# whowas replay
#sub c314($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($to, $user, $fqdn, $gcos) = $rest =~ m/^\S+ (\S+) (\S+) (\S+) \* :(.+)$/;
#}

# whowas replay λ
#sub c369 {
#}

# who replay
#sub c352($$$) {
#	my ($from, $where, $rest) = @_;
#	my ($chan, $user, $fqdn, $to, $mode, $hops, $toname) =
#	($rest =~ m/^\S+ (\S+) (\S+) (\S+) (\S+) ([HG]?[\@\+]?) :(\d+) (.*)/);
#}

# names replay
sub c353($$$) {
	my ($from, $where, $rest) = @_;
	my ($chan, $list) = (split(/ /, $rest, 4))[2, 3];
	
	$list =~ s/^://;
	&make_chans_names($chan, $list);
}

# 顼 c400-c599

# nick
sub c432($$$) {
	my ($from, $where, $rest) = @_;
	&log("˥å͡बʸåȤǹƤޤ");
	exit 1 if ($nick eq $rc_nick);
}

# ѹNickϤǤ˻ȤƤ
sub c433($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($connect_process == 1){
		if ($nick eq $rc_nick) {
			$nick_try_cnt = 0;
		} else {
			$nick_try_cnt++;
		}
		$nick = $rc_nick;
		if ($nick_try_cnt != 10) {
			$nick =~ s/^(........).$/$1/;
			$nick .= $nick_try_cnt;
		}
		&send("NICK $nick");
	}
}

# ERR_UNAVAILRESOURCE
sub c437($$$) {
	my ($from, $where, $rest) = @_;
	
	if ($connect_process == 1){
		if ($nick eq $rc_nick) {
			$nick_try_cnt = 0;
		} else {
			$nick_try_cnt++;
		}
		$nick = $rc_nick;
		if ($nick_try_cnt != 10) {
			$nick =~ s/^(........).$/$1/;
			$nick .= $nick_try_cnt;
		}
		&send("NICK $nick");
	}
}

sub c463($$$) {
	my ($from, $where, $rest) = @_;
	&log("ΥۥȤ餳ΥФˤ³Ǥޤ");
	exit 1;
}

sub c464($$$) {
	my ($from, $where, $rest) = @_;
	&log("³ɬפʥѥɤְäƤޤ");
	exit 1;
}

sub c465($$$) {
	my ($from, $where, $rest) = @_;
	&log("ʤϤΥФ³Ǥޤ");
	exit 1;
}

sub c471($$$) {
	my ($from, $where, $rest) = @_;
	&log("limit¤줿Ϳۤޤ");
}

sub c472($$$) {
	my ($from, $where, $rest) = @_;
	&log("̤Υͥ⡼ɤǤ");
}

sub c473($$$) {
	my ($from, $where, $rest) = @_;
	&log("banƤޤ");
}

sub c474($$$) {
	my ($from, $where, $rest) = @_;
	&log("Ƥޤ");
}

# about ctcp
sub ctrl_a_msg($$$$) {
	my ($from, $where, $to, $msg) = @_;
	
	&log("DEBUG: processing Ctrl-A message") if ($debug =~ m/^process$/mi);
	
	return unless ($where =~ m/jp$/i);
	my ($cmd, $rest) = split(/ /, $msg, 2);
	
	if (($ctcp_from_bak eq $from) && ($ctcp_cmd_bak eq $cmd) && (time - $ctcp_time_bak < 30)) {
		&log("Query from $from($to): $cmd $msg, but refuse.");
		return;
	}
	$ctcp_from_bak = $from;
	$ctcp_cmd_bak = $cmd;
	$ctcp_time_bak = time;
	
	if ($cmd =~ m/action/i) {
		if ($rest) {
			if ($to =~ /^[\#&]/) {
				if ($channel{$to}{member}{$from}) {
					&log("<$to:$from> *ACTION* $from $rest");
				} else {
					&log("($to:$from) *ACTION* $from $rest");
				}
			} else {
				&log("=$from= *ACTION* $from $rest");
			}
		}
		return;
	} elsif ($cmd =~ m/version/i) {
		&send("NOTICE $from :\001VERSION $version:\001");
	} elsif ($cmd =~ m/clientinfo/i) {
		&send("NOTICE $from :\001CLIENTINFO VERSION CLIENTINFO USERINFO PING TIME\001");
	} elsif ($cmd =~ m/userinfo/i) {
		&send("NOTICE $from :\001USERINFO :$rc_uinfo\001");
#	} elsif ($cmd =~ m/source/i) {
#		&send("NOTICE $from :\001SOURCE :$howget\001");
#	} elsif ($cmd =~ m/finger/i) {
#		&send("NOTIE $from :\001FINGER No support\001");
	} elsif ($cmd =~ m/time/i) {
		my @tm = localtime(time); $tm[4]++; $tm[5] += 1900;
		&send(sprintf("NOTICE %s :\001TIME %02d/%02d/%02d %02d:%02d:%02d\001", $from, @tm[5, 4, 3, 2, 1, 0]));
	} elsif ($cmd =~ /(ping|echo)/i) {
		&send("NOTICE $from :\001$msg\001");
	}
	&log("Query from $from($to): $cmd $msg");
}

