/*
 * main-puresv.c : main routine for pureserver binary.
 *
 * $Id: main-puresv.c,v 1.1 2000/12/30 16:31:42 simm Exp $
 */

#include "pure.h"

int main( int ac, char** av )
{
	net_peer peer;

	peer.name  = ( ac > 1 ) ? av[1] : NULL;
	peer.bport = ( ac > 2 ) ? atoi( av[2] ) : 0;
	peer.eport = ( ac > 3 ) ? atoi( av[3] ) : 0;
	if ( pure_server_wait( &peer, 0 ) < 0 )
		return 2;
	else
		return pure_loop( &peer );
}
