;;; pure-copyright.el --- Copyright for PURE and PURE-dependent modules

;; Copyright (C) 2000-2001 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@pure.fan.gr.jp>
;; Keywords: PURE, copyright

;; $Id: pure-copyright.el,v 1.3 2001/06/05 16:29:36 simm Exp $

;; These modules are free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; These modules are distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; You can FTP the latest stable version of PURE from
;;   ftp://ftp.fan.gr.jp/pub/elisp/pure/

;; You can get the latest stable informaton of PURE from WWW:
;;   http://pure.fan.gr.jp/pure/

;; You can get the latest version of PURE via anonymous CVS like below:
;;   cvs -d :pserver:anonymous@cvs.fan.gr.jp:/home/cvs checkout pure

;; You can get the latest information of PURE from IRC:
;;   (server)irc.friend.td.nu (port)6660-6669 (channel)#pure

;;; Code:

(defconst pure-pointer-ftp-url "ftp://ftp.fan.gr.jp/pub/elisp/pure/"
  "URL for PURE FTP pointer")
(defconst pure-pointer-www-url "http://pure.fan.gr.jp/pure/"
  "URL for PURE WWW pointer")
(defconst pure-pointer-cvs-pserver ":pserver:anonymous@cvs.fan.gr.jp:/home/cvs"
  "PSERVER name for PURE anonymous-CVS")
(defconst pure-pointer-cvs-tag "pure"
  "Tag name for PURE CVS")
(defconst pure-pointer-irc-server "irc.friend.td.nu"
  "Server hostname for PURE IRC channel")
(defconst pure-pointer-irc-port 6666
  "Server port number for PURE IRC channel")
(defconst pure-pointer-irc-channel "#pure"
  "Channel name for PURE IRC")

;; That's all
(provide 'pure-copyright)

;;; pure-copyright.el ends here
