(setq load-path (cons "." load-path))

(load-file "irchat-commands.el")
(load-file "irchat-copyright.el")
(load-file "irchat-dcc.el")
(load-file "irchat-filter.el")
(load-file "irchat-globals.el")
(load-file "irchat-handle.el")
(load-file "irchat-inlines.el")
(load-file "irchat-pj-coding-system.el")
(load-file "irchat-pj-jisx0201.el")
(load-file "irchat-pj-mode-line-format.el")
(load-file "irchat-pj-sound.el")
(load-file "irchat-pj-version-string.el")
(load-file "irchat-pj-sound.el")
(load-file "irchat-setpath.el")
(load-file "irchat-vars.el")
(load-file "irchat.el")

(defun Meadow-version (&rest args))
(defun make-char (&rest args))
(defun make-character (&rest args))
(defun define-service-coding-system (&rest args))
(defun define-service-kanji-code (&rest args))
(defun set-process-kanji-code (&rest args))
(defun code-convert-string (&rest args))
(defun convert-string-kanji-code (&rest args))
(defun modify-coding-system-alist (&rest args))
(defun encode-coding-string (&rest args))
(defun decode-coding-string (&rest args))
(defun skk-kakutei (&rest args))

(defvar caesar-translate-table nil)
(defvar fun nil)
(defvar hook nil)
(defvar irchat-away-indicator nil)
(defvar irchat-beep-indicator-local nil)
(defvar irchat-beep-local nil)
(defvar irchat-freeze-indicator nil)
(defvar irchat-freeze-indicator-local nil)
(defvar irchat-freeze-local nil)
(defvar irchat-hoge nil)
(defvar irchat-suppress-indicator-local nil)
(defvar irchat-suppress-local nil)
(defvar lc-jp nil)
(defvar mule-version nil)
(defvar start nil)
(defvar stop nil)
(defvar temp nil)
(defvar chan nil)
(defvar nick nil)
(defvar to-ascii-process nil)
(defvar to-kanji-process nil)
(defvar emacs-patch-level nil)
(defvar xemacs-betaname nil)
(defvar xemacs-codename nil)
(defvar rail-ja-mule-version nil)
(defvar rail-ja-meadow-version nil)
(defvar rail-ja-xemacs-codename nil)
(defvar rail-ja-utf-2000-version nil)
(defvar utf-2000-version nil)
(defvar skk-mode nil)
(defvar skk-henkan-on nil)
(defvar skk-egg-like-newline nil)

(defvar browse-url-plus-wget-process nil)
(or (fboundp 'thing-at-point)
    (defun thing-at-point (&rest args)))
(or (fboundp 'character-set)
    (defun character-set (&rest args)))
(or (fboundp 'char-leading-char)
    (defun char-leading-char (&rest args)))
(or (fboundp 'char-component)
    (defun char-component (&rest args)))
(or (fboundp 'charset-chars)
    (defun charset-chars (&rest args)))
(or (fboundp 'char-charset)
    (defun char-charset (&rest args)))

(and (fboundp 'char-bytes)
     (eq 1 (char-bytes ?$(B$"(B))
     (get 'char-bytes 'byte-compile)
     (put 'char-bytes 'byte-compile nil))
