;;; pure-vs-se.el --- 

;; Copyright (C) 2000 by Project Pure.

;; Author: SHIMADA Mitsunobu <simm@irc.fan.gr.jp>
;; Keywords: PURE, versio-string, single-byte, old, emacs

;; $Id: pure-vs-se.el,v 1.1.1.1 2000/07/31 18:57:39 simm Exp $

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Commentary:

;; PURE means "Primitive Universal Relay-chat Environment."
;; VS means version-string
;; This module is derived from irchat-pj-specific-other-emacsen.el

;;; Code:

(defconst pure-vs-emacs
  (or (and (boundp 'system-configuration)
	   (stringp system-configuration)
	   (format "Emacs %s (%s)" emacs-version system-configuration))
      (format "Emacs %s" emacs-version))
  "Emacs version string for PURE")

;; That's all
(provide 'pure-vs-se)

;;; pure-vs-se.el ends here
